//
// OCT97.CPP
//
// This program demonstrates a problem with template
// compilation under Visual C++ 5.0.  The problem
// shows up in class B<T>.  This class defines a
// couple of member functions, which would seem to
// have different argument types.  (As long as B
// is instantiated with a type argument other than
// int.)  But compiling this code using this command
// line:
//
//   cl /GX test.cpp
//
// yields the following error message:
//
//  error C2535: 'void B::Foo(class A)' :
//   member function already defined or declared
//
// The compiler should be able to distinguish the two
// different versions of Foo() in the class definition,
// since they clearly have different argument types.
//
template< typename T >
class A {
public:
    T value;
};

template< typename T >
class B
{
public:
    void Foo( A<T> a );
    void Foo( A<int> a );
};

void main()
{
    B<char> x;
}
